/*============================================================================*
 *  FILE: 
 *     struct.h
 *
 *  Description: 
 *     \̒`
 *
 *===========================================================================*/

/********** My Local structures **********/
#ifdef STRUCT_H
#else
#define STRUCT_H

// t@CQƎq
typedef struct {
  UInt16   fileLocation;
  FileRef  vfsRef;
  FileHand streamRef;
} NNshFileRef;

typedef struct {
    UInt32  NNsiVersion;
    UInt32  prefSize;
    UInt16  prefType;
    UInt16  debugMode;
} NNshSoftwareVersionInfo;

typedef struct {
    Char    tabName[MAX_BOARDNAME];        // ^u
    UInt16  newArrival;                    // VmF^u
    UInt16  getList;                       // ꗗ擾^u
    UInt16  condition;                     // 
    UInt16  boardNick;                     // ^u
    UInt16  boardCondition;                // w
    UInt16  threadLevel;                   // xݒ
    UInt16  threadStatus;                  // XԎw
    UInt16  threadCreate;                  // X쐬
    UInt16  stringSet;                     // w
    Char    string1[MINIBUF];              // P
    Char    string2[MINIBUF];              // Q
    Char    string3[MINIBUF];              // R
} NNshCustomTab;

typedef struct {
    UInt16 up;              // n[hL[
    UInt16 down;            // n[hL[
    UInt16 key1;            // n[hL[P
    UInt16 key2;            // n[hL[Q
    UInt16 key3;            // n[hL[R
    UInt16 key4;            // n[hL[S
    UInt16 jogPush;         // WO
    UInt16 jogBack;         // WOBack
    UInt16 clieCapture;     // CLIELv`(NX)
} NNshHardkeyControl;

// VXe(NɃf[^x[XǂݍޏAAA...)
typedef struct {
    /** NNsiݒ **/
    Char    handleName[BUFSIZE]; // Ren
    Char    bbs_URL   [MAX_URL]; // BBSꗗ擾ptqk
    Char    proxyURL  [MAX_URL]; // ProxỹzXg
    Int32   netTimeout;          // ʐM^CAEgl
    UInt16  getAllThread;        // SẴX擾
    UInt16  confirmationDisable; // mF_CAOȗ
    UInt16  openAutomatic;       // X擾㎩IɃI[v
    UInt16  writeAlwaysSage;     // sage
    UInt16  useBookmark;         // @\g
    UInt16  searchCaseless;      // p啶𖳎
    UInt16  offChkLaunch;        // NNsiNOFFLINEX
    UInt16  disableUnderline;    // XQƎUNDERLINE OFF
    UInt16  debugMessageON;      // fobObZ[W̕\
    UInt16  printNofMessage;     // XꗗŃX\
    UInt16  boldMessageNum;      // QƉʂŃXԍyzł
    UInt16  useVFS;              // VFSVXe̎gpېݒ
    UInt16  bufferSize;          // [N̈ƂĊmۂobt@TCY
    UInt16  partGetSize;         // bZ[WMTCY
    UInt16  enablePartGet;       // _E[h
    UInt16  lastFrmID;           // Iɕ\Ă
    UInt16  lastBBS;             // Iɕ\ĂBBS
    UInt16  openMsgIndex;        // \郁bZ[WINDEX(ԍ)
    UInt16  bookMsgIndex;        // BookmarkbZ[WINDEX
    UInt16  notCursor;           // QƎJ[\\Ȃ
    UInt16  bookMsgNumber;       // BookmarkbZ[Wԍ
    UInt16  openThreadIndex;     // \XXgԍ
    UInt16  useFixedHandle;      // Ren@\gp
    UInt16  disconnectNNsiEnd;   // NNsiIɉؒf
    UInt16  useProxy;            // ProxyoRł̃ANZX
    UInt16  proxyPort;           // Proxỹ|[gԍ
    UInt16  useCookieWrite;      // MCookiegpď
    UInt16  copyDelReadOnly;     // QƐpXɃRs[ƂAɍ폜
    UInt8   vfsUseCompactFlash;  // VFSgp\CFgp
    UInt8   vfsOnAutomatic;      // VFSgp\ɎIVFS ON
    UInt16  currentFont;         // tHgID(Starndardp)
    UInt16  notListReadOnly;     // "擾ςݑS"ɎQƐpO͕\Ȃ
    UInt16  redrawAfterConnect;  // ڑʂĕ`悷
    UInt16  insertReplyNum;      // ݎɎQƃXԍ}
    UInt16  useARMlet;           // PalmOS5p@\gp
    UInt16  sonyHRFont;          // (Sony HRp)TinytHg(QƗp)
    UInt16  sonyHRFontTitle;     // (Sony HRp)TinytHg(ꗗp)
    UInt16  useSonyTinyFont;     // (Sony HRp)TinytHggp
    UInt16  useSonyTinyFontTitle; // (Sony HRp)TinytHggp
    UInt16  notAutoFocus;        // ݎAIɏFieldɈړȂ
    UInt16  writeBufferSize;      // Xꗗɕ\^Cg̒
    UInt16  browseMesNum;        // BrowserŊJbZ[Wԍ
    UInt16  disconnArrivalEnd;   // uVmFvIɉؒf
    UInt16  autoOpenNotRead;     // uVmFvIɁuǂv
    UInt16  addReturnToList;     // JumpListɁuꗗ֖߂vǉ
    UInt16  notUseSilk;          // SilksȂ
    UInt16  writeSequence2;      // ݃V[PXPART2
    UInt16  startTitleRec;       // \^Cgꗗ̐擪R[h
    UInt16  endTitleRec;         // \^Cgꗗ̖R[h
    UInt16  currentSelectRec;    // \^Cgꗗ̑IR[h
    UInt16  selectedTitleItem;   // \^Cgꗗ̑IXgԍ
    UInt16  titleDispState;      // ^Cgꗗ\
    UInt16  convertHanZen;       // QƎApJiSpJiϊ
    UInt16  addLineDisconn;      // QƎAIj[ɉؒf
    UInt16  addLineGetPart;      // QƎAIj[ɍ擾
    UInt16  addJumpTopMsg;       // QƎAIj[ɐ擪
    UInt16  addJumpBottomMsg;    // QƎAIj[ɖ
    UInt16  addMenuSelAndWeb;    // QƎAIɑSI+WebBrowserŊJ
    UInt16  addMenuMsg;          // QƎAIɃj[ǉ 
    UInt16  addMenuBackRtnMsg;   // QƎAIɁuP߂vǉ 
    UInt16  addMenuGraphView;    // QƎAIɁu`惂[hύXvǉ
    UInt16  addMenuFavorite;     // QƎAIɁuCɓؑցvǉ
    UInt16  addMenuOutputMemo;   // QƎAIɁu֏óvǉ
    UInt16  addDeviceInfo;       // QƎAIɃfoCXǉ 
    UInt16  addMenuTitle;        // ꗗAIɃj[ǉ 
    UInt16  addMenuDeleteMsg;    // ꗗAIMSG폜ǉ 
    UInt16  addMenuCopyMsg;      // ꗗAIɎQƐpփRs[ǉ 
    UInt16  addMenuGetMode;      // ꗗAIɃX擾[hؑ
    UInt16  addMenuGraphTitle;   // ꗗAIɁu`惂[hύXvǉ
    UInt16  addMenuMultiSW1;     // ꗗAIɑړIXCb`Pǉ
    UInt16  addMenuMultiSW2;     // ꗗAIɑړIXCb`Qǉ
    UInt16  addMenuNNsiEnd;      // ꗗAINNsiIǉ 
    UInt16  addMenuDeviceInfo;   // ꗗAIɃfoCXǉ 
    UInt16  disableSonyHR;       // SONYnC]`惂[hgpȂ
    UInt16  useColor;            // J[\gp
    UInt8   colorError;          // G[̃J[
    UInt8   colorOver;           // 1000̃J[
    UInt8   colorNotYet;         // 擾X̃J[
    UInt8   colorNew;            // VX̃J[
    UInt8   colorUpdate;         // XVX̃J[
    UInt8   colorRemain;         // ǂX̃J[
    UInt8   colorAlready;        // Sēǂ񂾃X̃J[
    UInt8   colorUnknown;        // sȃX̃J[
    UInt8   colorBackGround;     // ꗗʂ̔wiF
    UInt8   colorButton;         // ㉺{^̐F
    UInt8   colorViewBG;         // QƉʂ̔wiF
    UInt8   colorViewFG;         // QƉʂ̕F
    UInt16  notDelOffline;       // OFFLINEXɃXȂ
    UInt16  notFocusNumField;         // XQƉʂŃtH[JXړȂ
    UInt16  disableUnderlineWrite;    // ݎA_[COFF
    UInt16  usageOfTitleMultiSwitch1; // Xꗗʂ̑ړIXCb`P
    UInt16  usageOfTitleMultiSwitch2; // Xꗗʂ̑ړIXCb`Q
    UInt16  autoDeleteNotYet;         // ړɖ擾폜
    UInt16  notCheckBBSURL;           // URL̗L`FbNȂ
    UInt16  displayFavorLevel;        // Cɓɕ\ŒXx
    UInt16  newArrivalNotRead;        // uǂv^uł̐VmF
    UInt16  getReserveFeature;        // X擾\@\g
    Char    searchStrMessage[MAX_SEARCH_STRING]; // X
    UInt32  searchMode;               // [h
    UInt16  bbsOverwrite;             // BBSꗗ㏑
    UInt16  useImodeURL;              // ꗗŃuEUJƂi-modep
    UInt16  nofRetry;                 // ʐM^CAEg̃gC
    UInt16  autoUpdateGetError;       // 擾sɍĎ擾
    UInt16  dispBottom;               // bZ[W𖖔\ł悤
    UInt16  blockDispMode;                 // QƎAXA\
    Char    multiBtn1Caption[MAX_CAPTION]; // ړI{^P̃{^x
    Char    multiBtn2Caption[MAX_CAPTION]; // ړI{^Q̃{^x
    Char    multiBtn3Caption[MAX_CAPTION]; // ړI{^R̃{^x
    Char    multiBtn4Caption[MAX_CAPTION]; // ړI{^S̃{^x
    Char    multiBtn5Caption[MAX_CAPTION]; // ړI{^T̃{^x
    Char    multiBtn6Caption[MAX_CAPTION]; // ړI{^Ũ{^x
    UInt16  multiBtn1Feature;              // ړI{^PFeature
    UInt16  multiBtn2Feature;              // ړI{^QFeature
    UInt16  multiBtn3Feature;              // ړI{^RFeature
    UInt16  multiBtn4Feature;              // ړI{^SFeature
    UInt16  multiBtn5Feature;              // ړI{^TFeature
    UInt16  multiBtn6Feature;              // ړI{^UFeature

    NNshHardkeyControl useKey;             // n[hL[̑
    NNshHardkeyControl ttlFtr;             // ꗗʂł̃n[hL[
    NNshHardkeyControl viewFtr;            // QƉʂł̃n[hL[

    UInt16  useHardKeyControl;             // n[hL[𐧌䂷
    UInt16  checkDuplicateThread;          // ꗗ\ɏd̊mFs
    UInt16  hideMessage;                   // [邠ځ[{
    Char    hideWord1[HIDEBUFSIZE];        // ځ[L[[hP
    Char    hideWord2[HIDEBUFSIZE];        // ځ[L[[hQ
    NNshCustomTab custom1;                 // [UݒP
    NNshCustomTab custom2;                 // [UݒQ
    NNshCustomTab custom3;                 // [UݒR
    NNshCustomTab custom4;                 // [UݒS
    NNshCustomTab custom5;                 // [UݒT
    UInt16  writeJogPushDisable;           // ݎPUSH{^𖳌
    UInt16  enableNewArrivalHtml;          // ܂BBS/@JBBS̐VL
    UInt16  useRegularExpression;          // NG[hŐK\gp
    UInt16  vfsOnNotDBCheck;               // VFS ONłDB`FbNȂ
    UInt16  writeMessageAutoSave;          // ݉ʏIAXۑ
    Char    launchPass[PASSSIZE];          // NL[[hݒ
    UInt16  readOnlySelection;             // QƐpOfBNgIԍ
    UInt16  addMenuDirSelect;              // ꗗʃj[DirIǉ
} NNshSavedPref;

// (f[^x[X̍\)
typedef struct {
    Char   boardNick[MAX_NICKNAME];    // {[hjbNl[ 
    Char   boardURL [MAX_URL];         // {[hURL
    Char   boardName[MAX_BOARDNAME];   // {[h
    UInt8  bbsType;                    // {[hTYPE
    UInt8  state;                      // {[hgp
    Int16  reserved;                   // (\̈FȑO͎gpĂ)
} NNshBoardDatabase;

// X(f[^x[X̍\)
typedef struct {
    Char   threadFileName[MAX_THREADFILENAME]; // {[h
    Char   threadTitle   [MAX_THREADNAME];     // X
    Char   boardNick     [MAX_NICKNAME];       // {[hjbNl[ 
    UInt16 dirIndex;                           // X̃fBNgIndexԍ
    UInt16 reserved;                           // (gp)
    UInt8  state;                              // bZ[W擾
    UInt8  msgAttribute;                       // bZ[W̑
    UInt8  msgState;                           // bZ[W̋L^
    UInt8  bbsType;                            // BBS(bZ[W)̎擾`
    UInt16 maxLoc;                             // ő僁bZ[Wԍ
    UInt16 currentLoc;                         // \bZ[Wԍ
    UInt32 fileSize;                           // t@CTCY
} NNshSubjectDatabase;

// Xi[fBNg(f[^x[X̍\)
typedef struct {
    UInt16   dirIndex;                         // fBNgIndex(ID)
    Char     boardNick[MAX_NICKNAME];          // {[hjbNl[ 
    Char     dirName[MAX_DIRNAME];             // fBNg
    UInt16   previousIndex;                    // ЂƂ̃fBNgIndex
    UInt32   depth;                            // fBNg̐[x
    UInt32   reserved;                         // \P
} NNshDirectoryDatabase;

// CfbNX(ꎞ̈)
typedef struct {
    UInt16   bbsIndex;                 // gpBBSINDEX(ɂ͐擪)
} NNshBBSRelation;


// BBSgp(ꎞ̈ABBSIʂŎgp)
typedef struct
{
  Int16    currentPage;                // ݕ\Ăy[Wԍ
  Int16    maxPage;                    // ő̃y[Wԍ
  UInt16   nofRecords;                 // BBS̃R[h
  UInt16   nofRow;                     // 1y[Wɕ\\BBS
  UInt16  *checkBoxState;              // `FbN{bNX̐(SBBS)
  Char    *BBSName_Temp;               // aarXg(ʂɕ\鐔)
  UInt32   BBSName_size;               // aarXg̑傫
  Char     searchName[MAX_BOARDNAME];  // w肷镶
  Char     PageLabel[BBSSEL_PAGEINFO]; // \y[Wi[̈
} NNshBBS_Temp_Info;

// \̃bZ[W(ꎞ̈)
typedef struct
{
    UInt32      nofMsg;                // ǂݍ񂾃X̍ő僁bZ[Wԍ
    UInt16      openMsg;               // ݊JĂ郁bZ[Wԍ
    UInt16      dispMsg;               // \Ă郁bZ[W
    UInt16      nofJump;               // Wv
    UInt16      jumpMsg[JUMPBUF];      // XQƔԍ߂̐
    UInt16      histIdx;               // OJbZ[Wԍ
    UInt16      prevMsg[PREVBUF];      // OJbZ[Wobt@
    UInt32      fileSize;              // ǂݍݒt@C̃t@C
    UInt32      msgOffset[NNSH_MESSAGE_MAXNUMBER]; // XCfbNX
    UInt16      reserved;              // (\)
    UInt16      bbsType;               // BBS^Cv
    EventType   event;                 // _~[̃Cxgpf[^
    Char       *jumpListTitles;        //
    MemHandle   jumpListH;             //
    NNshFileRef fileRef;
    UInt32      fileOffset;            // Ǎłf[^̐擪offset
    UInt32      fileReadSize;          // ݃obt@ɓǂݍłf[^
    Char        showTitle  [MAX_THREADNAME]; // X^Cg(ʕ\p)
    Char        threadTitle[MAX_THREADNAME]; // X
    Char        threadFile [MAX_THREADFILENAME]; // XID
    Char        boardNick  [MAX_NICKNAME];  // {[hjbNl[ 
    Char        buffer     [MARGIN];        // f[^obt@(ۂ͂Ƃ)
} NNshMessageIndex;

// BbZ[W̃[N̈\
typedef struct
{
    UInt16    nofWord;        // (Xg)
    Char     *wordString;     // ̗̈(Xg`)
    MemHandle wordmemH;       // 񃊃Xgf[^
} NNshWordList;

// Field 𕪊Ƃ̗̈`
typedef struct
{
  UInt16 startX;
  UInt16 startY;
  UInt16 endX;
  UInt16 endY;
} fieldRegion;

//  NNsiŜŎgpO[ö
typedef struct
{
    MemHandle   searchTitleH;
    MemHandle   boardIdxH;
    MemHandle   logPrefixH;
    MemHandle   bbsTitleH;
    UInt32      palmOSVersion;       // foCXOSo[W
    UInt16      updateDatabaseInfo;  // DBAbvf[gꂽ
    UInt16      useBBS;
    UInt16      netRef;              // lbg[NQƔԍ
    UInt16      device;
    UInt16      vfsVol;
    UInt16      browserLaunchCode;   // WebBrowserLaunch Code
    UInt32      browserCreator;      // WebBrowserCreatorID
    UInt16      prevHRWidth;         // OtBbN[h\p(ModeL)
    UInt16      totalLine;           // OtBbN[h\p(Ss)
    UInt16      nofPage;             // OtBbN[h\p(Sy[W)
    UInt16      currentPage;         // OtBbN[h\p(\y[W)
    UInt16      prevHRLines;         // CLIEnC]\p(\\sL)
#ifdef USE_CLIE
    UInt16      updateHR;            // SILKTCYύXAʕ\XV
    UInt16      hrRef;               // SONY HRQƔԍ
    UInt16      hrVer;               // Sony HR̃o[Wԍ
    UInt16      notUseHR;            // HRsȂ
    UInt16      notUseSilk;          // SilksȂ
    UInt16      silkRef;             // CLIEpSILK}l[W̎QƔԍ(Temp)
    UInt16      silkVer;             // CLIEpSILK}l[WVersionԍ(Temp)
    UInt16     *jogInfoBack;         // SONYWOobNAbv
    UInt16    **jogAssistSetBack;    // SONYWOAVXgobNAbv
    UInt16      tempStatus;          //
#endif // #ifdef USE_CLIE
#ifdef USE_COLOR
    RGBColorType fgColor;                // OiF
    RGBColorType bgColor;                // wiF
    RGBColorType txColor;                // eLXgF
    RGBColorType bgFormColor;            // (tH[)wiF
    RGBColorType bgDialogColor;          // (_CAO)wiF
    RGBColorType bgAlertColor;           // (A[g)wiF
    RGBColorType bgObjectColor;          // (IuWFNg)wiF
#endif  // #ifdef USE_COLOR
    UInt32             os5HighDensity;   // 𑜓xT|[g̗L
    UInt16             jumpSelection;    // WvI(+ ꗗʋ@\sԍ)
    EventType          dummyEvent;       // Cxgpobt@
    Char               dummyBuffer[MARGIN];
    FormType          *prevBusyForm;
    Char              *bbsTitles;

    UInt16             nofTitleItems;   // X^Cg
    Char              *msgListStrings;  // X^Cgf[^i[̈
    Char              **msgTitleIndex;  // (1Ƃ)X^Cg擪
    UInt16            *msgListIndex;    // ^CgXgXR[hԍϊ
    UInt16            *msgTitleStatus;  // (1Ƃ)X^Cg
    UInt16            *msgNumbers;      // (1Ƃ)bZ[W

    NNshBBS_Temp_Info *tempInfo;
    NNshMessageIndex  *msgIndex;
    fieldRegion        fieldPos[2];       // QƉʂ̊ë
    Char              *bookmarkFileName;  // ݒ莞̃XID
    Char              *bookmarkNick;      // ݒ莞̃XNick
    Char               restoreSetting;          // ݒ̕
    MemHandle          listHandle;        // Xgnh
    NNshWordList       hide1;             // NGݒPXg
    NNshWordList       hide2;             // NGݒQXg
    NNshWordList      *featureList;       // @\ݒ胉x
    UInt16             featureLockCnt;    // @\ݒ胉x̃bN
} NNshWorkingInfo;

typedef struct {
    UInt8 importDB:1;                        // DB 𕜌邩ǂ
    UInt8 deleteFile:1;                        // VFS  DB폜邩ǂ
    UInt8 fileExist:1;                        // VFS  DB 邩ǂ
    UInt32 modDateVFS;                        // VFS  DB ̍XV
    UInt32 modDateMEM;                        // MEM  DB ̍XV
    Char dateStrMEM[24];
    Char dateStrVFS[24];
} NNshVFSDBInfo;

// DB ̏擾p
typedef struct {
    Char *nameP;
    UInt16 *attributesP;
    UInt16 *versionP;
    UInt32 *crDateP;
    UInt32 *modDateP;
    UInt32 *bckUpDateP;
    UInt32 *modNumP;
    LocalID *appInfoIDP;
    LocalID *sortInfoIDP;
    UInt32 *typeP;
    UInt32 *creatorP;
} NNshDBInfo;

typedef struct {
  UInt16  popId;
  UInt16  lstId;
} NNshListItem;

#if 0
// pingp ICMPpPbg\
typedef struct {
  UInt8  icmp_type;
  UInt8  icmp_code;
  UInt16 icmp_cksum;
  UInt16 icmp_id;
  UInt16 icmp_seq;
  UInt8  icmp_data[32];
} ICMP_packet;

// IPpPbg\(PINGp)
typedef struct {
  UInt8       ip_ver;
  UInt8       ip_tos;
  UInt16      ip_len;  
  UInt16      ip_id;
  UInt16      ip_off;
  UInt8       ip_ttl;
  UInt8       ip_p;
  UInt16      ip_sum;
  NetIPAddr   ip_src;
  NetIPAddr   ip_dst;
  ICMP_packet icmp;
} PING_packet;
#endif
#endif
